library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity Comparator is
	generic (
		NBits : integer := 4
	);
	port (
		A           : in std_logic_vector((NBits - 1) downto 0);
		B           : in std_logic_vector((NBits - 1) downto 0);
		AGreatThanB : out std_logic;
		ALessThanB  : out std_logic;
		AEqualB     : out std_logic
	);
end Comparator;
 
architecture Architecture1 of Comparator is
signal Equal : std_logic;
signal Great : std_logic;
begin
	Equal <= '1' when (A = B) else '0';
	Great <= '1' when (A > B) else '0';
	AEqualB <= Equal;
	AGreatThanB <= Great;
	ALessThanB <= not(Equal) and not(Great);
end Architecture1;
