library ieee;
use ieee.std_logic_1164.all;

entity FullAdder is
	port (
		A    : in std_logic;
		B    : in std_logic;
		Cin  : in std_logic;
		Y    : out std_logic;
		Cout : out std_logic
	);
end FullAdder;
 
architecture Architecture1 of FullAdder is
	component HalfAdder is
		port (
			A    : in std_logic;
			B    : in std_logic;
			Y    : out std_logic;
			Cout : out std_logic
		);
	end component;
	signal S1 : std_logic;
	signal S2 : std_logic;
	signal S3 : std_logic;
begin
	H1 : HalfAdder port map (
		A => A,
		B => B,
		Y => S1,
		Cout => S2
	);
	H2 : HalfAdder port map (
		A => S1,
		B => Cin,
		Y => Y,
		Cout => S3
	);
	Cout <= S2 or S3;
end Architecture1;
