library ieee;
use ieee.std_logic_1164.all;

entity LFSR10 is
	port (
		Reset  : in std_logic;
		Enable : in std_logic;
		Clk    : in std_logic;
		Data   : out std_logic_vector(9 downto 0)
	);
end LFSR10;
 
architecture Architecture1 of LFSR10 is
signal QBus : std_logic_vector(9 downto 0);
signal DBus : std_logic_vector(9 downto 0);
signal PreDBus : std_logic_vector(9 downto 0);
begin
	-- D FFs with synchronous reset
	process (Clk, Reset)
	begin
		if (Clk'event and (Clk = '1')) then
			if (Reset = '1') then
				QBus <= "1000000000";
			else
				QBus <= DBus;
			end if;
		end if;
	end process;

	-- enable logic
	DBus <= PreDBus when (Enable = '1') else QBus;
	-- LFSR logic x^10 + x^7 + 1
	PreDBus(9) <= QBus(0) xor QBus(3);
	PreDBus(8 downto 0) <= QBus(9 downto 1);
	Data <= QBus;
end Architecture1;
