library ieee;
use ieee.std_logic_1164.all;

entity LFSR10_tb is
end LFSR10_tb;

architecture Architecture1 of LFSR10_tb is
	component LFSR10 is
		port (
			Reset  : in std_logic;
			Enable : in std_logic;
			Clk    : in std_logic;
			Data   : out std_logic_vector(9 downto 0)
		);
	end component;
	signal ResetTb : std_logic;
	signal EnableTb : std_logic;
	signal ClkTb : std_logic := '0';
	signal ClkOk : std_logic;
	signal DataTb : std_logic_vector(9 downto 0);
begin
	Test : LFSR10 port map (
		Reset => ResetTb,
		Enable => EnableTb,
		Clk => ClkTb,
		Data => DataTb
	);
	EnableTb <= '1';
	ClkOk <= '1' after 0 ns, '0' after 15 ns;
	ClkTb <= not(ClkTb) after 0.5 ns when (ClkOk = '1') else '0';
	ResetTb <= '0' after 1 ns, '1' after 2 ns, '0' after 3 ns;
end Architecture1;
