library ieee;
use ieee.std_logic_1164.all;

entity Latch is
	generic (
		NBits : integer := 8
	);
	port (
		Enable  : in std_logic;
		Clk     : in std_logic;
		DataIn  : in std_logic_vector((NBits - 1) downto 0);
		DataOut : out std_logic_vector((NBits - 1) downto 0)
	);
end Latch;

architecture Architecture1 of Latch is
signal QBus : std_logic_vector((NBits - 1) downto 0);
signal DBus : std_logic_vector((NBits - 1) downto 0);
signal PreDBus : std_logic_vector((NBits - 1) downto 0);
begin
	process (Clk)
	begin
		if (Clk'event and (Clk = '1')) then
			QBus <= DBus;
		end if;
	end process;

	DBus <= PreDBus when (Enable = '1') else QBus;
	PreDBus <= DataIn;
	DataOut <= QBus;
end Architecture1;
