library ieee;
use ieee.std_logic_1164.all;

entity ShiftRegister is
	generic (
		NBits : integer := 8
	);
	port (
		Enable         : in std_logic;
		Clk            : in std_logic;
		SerialInput    : in std_logic;
		ParallelOutput : out std_logic_vector((NBits - 1) downto 0)
	);
end ShiftRegister;

architecture Architecture1 of ShiftRegister is
signal QBus : std_logic_vector((NBits - 1) downto 0);
signal DBus : std_logic_vector((NBits - 1) downto 0);
signal PreDBus : std_logic_vector((NBits - 1) downto 0);
begin
	process (Clk)
	begin
		if (Clk'event and (Clk = '1')) then
			QBus <= DBus;
		end if;
	end process;

	DBus <= PreDBus when (Enable = '1') else QBus;
	PreDBus(NBits - 1) <= SerialInput;
	PreDBus((NBits - 2) downto 0) <= QBus((NBits - 1) downto 1);
	ParallelOutput <= QBus;
end Architecture1;
